<?php

/**
 * @property CI_Loader $load
 * @property CI_Form_validation $form_validation
 * @property CI_Input $input
 * @property CI_Email $email
 * @property CI_Session $session
 * @property CI_DB_active_record $db
 * @property CI_Pagination $pagination
 * @property CI_upload $upload
 */
class Robot extends MY_Controller
{
    function __construct()
    {
        parent::__construct();

    }

    function index()
    {
        $this->robot_view('robot/index');
    }

    function start_chat(){
        $this->load->library('form_validation');
        $this->form_validation->set_rules('client-email', "client-email", 'trim|xss_clean|htmlspecialchars|required');
        if ($this->form_validation->run() == true) {
            $this->session->set_userdata('client-email', $this->input->post('client-email'));
        }
        redirect('robot');
    }

    function sent_messages()
    {
        $message = html_escape($this->input->post('message', true));
        
        $messages = array();
        $messages[0] = $message;

        if ($message) {
            $this->save_message($message);
            $response = $this->find_response($message);
            $this->save_message($response);  // save the robot reply in messages
        }

        $messages[1] = $response;
        $messages[2] = time();
        $vars['messages'] = $messages;
        $this->load->view('robot/sent_messages', $vars);
    }

    function find_response($message = '')
    {
    


        $matched_commands = $this->db->query('SELECT `command`,`response`
                                              FROM social_commands
                                              WHERE MATCH (`command`) AGAINST("' . $message . '" IN NATURAL LANGUAGE MODE)
                                              OR command LIKE "%' . $message . '"
                                              OR command LIKE "' . $message . '%"
                                              limit 1
                                          ');



        if (is_object($matched_commands)) {
            if ($matched_commands->num_rows() > 0) {
                return $matched_commands->row()->response;
            }
        }

        return option_get('default-cannot-understand-message');
    }

    function save_email()
    {
        $email = $this->input->post('email');
        $this->session->set_userdata(array('customer-email' => $email));
    }

    private function save_message($message = '', $type = '0')
    {
        $obj = new stdClass();
        //$obj->ip = $_SERVER['REMOTE_ADDR'];
        $obj->ip = $_SERVER['SERVER_ADDR'];
        $obj->email = $this->session->userdata('client-email');
        $obj->message = $message;
        $obj->type = $type; // client or robot
        $obj->created_date = time();
        $obj->was_helpful = 0;
        $obj->date = date('Y-m-d');
        $this->db->insert('messages', $obj);
    }
}